/**
 *  Class ChatDialog.java
 *  @author: Anders Sandstrom
 *  UCCS 1997
 */
import java.awt.*;
import java.util.*;
public class ChatDialog extends Dialog {

  // Variable declarations
  private String userName;
  private TextArea chatArea;
  private TextField input;
  private Button sendButton;
  private Button closeButton;
  private ResultProcessor owner ;
  private Vector names;
  private Color colors[]={Color.black,Color.blue,Color.cyan,
                  Color.green,Color.magenta,Color.orange,
                  Color.pink,Color.red,Color.yellow};

  // Constructor
  public ChatDialog(Frame parent,String title,boolean modal,ResultProcessor javadraw,String name) {
	  super(parent, title, modal);
	  owner=javadraw;
	  userName=name;
    setup();
  }

  // Method setup()
	void setup(){
    //setLayout(new BorderLayout());
    names=new Vector();
    names.addElement(userName);
    setupGUI();
  }

  // Method show()
  public void show() {
    Rectangle bounds = getParent().bounds();
    Rectangle abounds = bounds();
    move(bounds.x + (bounds.width - abounds.width)/ 2,
    	   bounds.y + (bounds.height - abounds.height)/2);
    super.show();
  }

  // Method wakeUp()
  public synchronized void wakeUp() {
    notify();
  }

  /*public boolean handleEvent(Event event) {
    if(event.id == Event.WINDOW_DESTROY) {
      hide();
      return true;
    }
    //return false;
  }*/

  // Method keyDown()
  public boolean keyDown(Event event,int key){
    if(key==10){
      handleInput();
      return true;
    }
    return false;
  }

  // Method action()
  public boolean action(Event event,Object what){
    if(event.target == sendButton){
      handleInput();
      return true;
    }
    else if(event.target == closeButton){
        hide();
        return true;
    }

    return false;
  }

  // Method handleInput()
  void handleInput(){
    String msg=input.getText();
    System.out.println("msg: ."+msg+".");
    input.setText("");
    if(msg!=""){

      printToLocal(msg);
      owner.sendChatData(encodeMessage(msg));
    }
  }

  // Method printToLocal()
  void printToLocal(String msg){
    String string=new String(userName+": "+msg+"\n");
    //chatArea.setForeground(colors[getColorIndex(userName)]);
    chatArea.appendText(string);
  }

  // Method printRemote()
  void printRemote(String name,String msg){
    String string=new String(name+":"+decodeMessage(msg)+"\n");
    //chatArea.setForeground(colors[getColorIndex(name)]);
    chatArea.appendText(string);
  }

  // Method encodeMessage()
  String encodeMessage(String msg){
    StringTokenizer encoder=new StringTokenizer(msg);
    String temp="";
    while(encoder.hasMoreTokens()) {
      temp=new String(temp+"(y)"+encoder.nextToken());
    }
    return temp;
  }

  // Method decodeMessage()
  String decodeMessage(String msg){
    StringTokenizer decoder=new StringTokenizer(msg,"(y)");
    String temp="";
    while(decoder.hasMoreTokens()) {
      temp=new String(temp+" "+decoder.nextToken());
    }
    return temp;
  }

  //inserNewLine
  /*String insertNewLine(String string){
    if(string.length<40) return string;
    else{
      for(int i=0;i<string.length/40;i++){
       */
  // Method getColorIndex()
 /* int getColorIndex(String name){
    int index=0;
    for(int i=0;i<names.size();i++){
      if(((String)names.elementAt(i))==name) index=i;
    }
    if(index==0){
      names.addElement(name);
      index=names.size()-1;
    }
    return index;
  }*/




  // setupGUI()
  void setupGUI(){
    setLayout(new BorderLayout());//new FlowLayout());
    setBackground(Color.lightGray);
    Panel northPanel=new Panel();
    northPanel.setLayout(new FlowLayout());
    Panel centerPanel=new Panel();
    centerPanel.setLayout(new FlowLayout());
    Panel southPanel=new Panel();
    southPanel.setLayout(new FlowLayout());
    chatArea=new TextArea(7,50);
    input=new TextField(40);
    input.requestFocus();
    chatArea.setBackground(Color.white);
    chatArea.setForeground(Color.red);
    chatArea.setEditable(false);
    //chatArea.setText((chatArea.preferredSize()).toString());
    //northPanel.add(chatArea);
    northPanel.add(chatArea);
    centerPanel.add(input);
    centerPanel.add(sendButton=new Button("Send"));
    southPanel.add(closeButton=new Button("Close"));
    add("North",northPanel);
    add("Center",centerPanel);
    add("South",southPanel);

    pack();
    resize(500,250);
    setResizable(true);

  }

}