// ConnectDialog.java
import java.awt.*;

/**
 *  Class ConnectDialog2
 *  @author: Anders Sandstrom
 *
 */
public class ConnectDialog2 extends Dialog {

    //{{DECLARE_CONTROLS
    TextField nameField;
    TextField conferenceNameField;
    TextField serverPortField;
    TextField serverIpField;
    TextField messageField;

    Label nameLabel;
    Label serverPortLabel;
    Label serverIpLabel;
    Label conferenceNameLabel;

    Label messageLabel;
    Button connectButton;
    Button cancelButton;

    ConnectInfo connectInfo;

    boolean debug=true;
    //}}

    /**
     *  Constructor ConnectDialog2:
     */
    public ConnectDialog2(Frame parent,String heading,boolean modal,ConnectInfo cInfo) {

        super(parent,heading, modal);
        connectInfo=cInfo;
	    setup();
        pack();
        setResizable(false);
        init();
    }

   /* public ConnectDialog2(Dialog parent,String heading,boolean modal,ConnectInfo cInfo) {

        super(parent,heading, modal);
        connectInfo=cInfo;
	    setup();
        pack();
        setResizable(false);
        init();
    }*/

	/**
	 *  Method setup():
	 *  The code in this method sets up the Dialog user interface
	 *  and is generated by Symantic Cafe's resource editor.
	 *
	 *  Future development:
	 *  The layout should be convereted to Gridbaglayout to ensure
	 *  portability.
	 */

	void setup(){
        //setForeground(Color.lightGray);
        //setBackground(Color.lightGray);
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 403, insets().top + insets().bottom + 292);
        nameField=new TextField(connectInfo.userName,19);
        add(nameField);
        nameField.reshape(insets().left + 176,insets().top + 40,198,24);
        conferenceNameField=new TextField(connectInfo.conferenceName,19);
        add(conferenceNameField);
        conferenceNameField.reshape(insets().left + 176,insets().top + 136,198,24);
        serverPortField=new TextField(connectInfo.serverPort,19);
        add(serverPortField);
        serverPortField.reshape(insets().left + 176,insets().top + 104,198,24);
        serverIpField=new TextField(connectInfo.serverIp,19);
        add(serverIpField);
        serverIpField.reshape(insets().left + 176,insets().top + 72,198,24);
        nameLabel=new Label("Name");
        add(nameLabel);
        nameLabel.reshape(insets().left + 23,insets().top + 48,139,16);
        serverPortLabel=new Label("Server Port");
        add(serverPortLabel);
        serverPortLabel.reshape(insets().left + 23,insets().top + 112,139,16);
        serverIpLabel=new Label("Server IP");
        add(serverIpLabel);
        serverIpLabel.reshape(insets().left + 23,insets().top + 80,139,16);
        conferenceNameLabel=new Label("Conference Name");
        add(conferenceNameLabel);
        conferenceNameLabel.reshape(insets().left + 23,insets().top + 144,139,16);
        messageField=new TextField(24);
        messageField.setEditable(false);
        messageField.setBackground(Color.lightGray);
        add(messageField);

        messageField.reshape(insets().left + 131,insets().top + 232,243,24);
        messageLabel=new Label("Message");
        add(messageLabel);
        messageLabel.reshape(insets().left + 27,insets().top + 240,90,16);
        connectButton=new Button("Connect");
        add(connectButton);
        connectButton.reshape(insets().left + 36,insets().top + 184,117,32);
        cancelButton=new Button("Cancel");
        add(cancelButton);
        cancelButton.reshape(insets().left + 257,insets().top + 184,117,32);
    }

    /**
     *  Method init():
     *  Initialization of connectDialog2.
     */
    void init(){
        if(debug)System.out.println("=========================================");
        if(debug) System.out.println("Initialization of ConnectToDialog2.");
        nameField.requestFocus();
        nameField.selectAll();
        if(debug) System.out.println("nameField: "+nameField.toString());
        if(debug) System.out.println("End of ConnectToDialog2 init.");
        if(debug)System.out.println("=========================================");
    }

    /**
     *  Method show():
     *  This method puts the dialog box centered on top of parent.
     */
    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    /**
     *  Method wakeup():
     */
    public synchronized void wakeUp() {
    	notify();
    }

    /**
     *  Method hadleEvent():
     */
    public boolean handleEvent(Event event) {
        if (event.id == Event.ACTION_EVENT && event.target == cancelButton) {
                clickedCancelButton();
                return true;
        }
        else
        if (event.id == Event.ACTION_EVENT && event.target == connectButton) {
                clickedConnectButton();
                return true;
        }
        else

        /*if (event.id == Event.WINDOW_DESTROY) {
    	    hide();
    	    return true;
    	}*/
    	return super.handleEvent(event);
    }

    /**
     *  Method keyDown:
     *  This method detects key presses and is used for
     *  decting Tab, Tab+Shift and Enter.
     *
     *  Future development:
     *  Brute force coded, not very elegant.
     */
    public boolean keyDown(Event event, int key){
        if(debug) System.out.println("key="+key);
        if (key==9 /* Tab */ && (event.modifiers & Event.SHIFT_MASK /* +Shift */)!=0){
            boolean shift= true;
            if(debug) System.out.println("Tab + Shift");
            handleTab(event,shift);
            return true;
        }
        else if(key==9 /* Tab || key==10 /* Enter */ ){
            boolean shift= false;
            if(debug) System.out.println("Tab");
            handleTab(event,shift);
            return true;
        }
        else if(key==10){
            clickedConnectButton();
            return true;
        }
        return false;
    }

    /**
     *  Method handleTab:
     *  This method makes toggel between objects possible.
     *  Tab moves focus to next object and Tab+Shift moves
     *  focus to previous object
     *
     *  Future development:
     *  Brute force coded, not very elegant.
     */
    public void handleTab(Event event,boolean shift){
        if(event.target==nameField){
            if(shift) cancelButton.requestFocus();
            else{
                serverIpField.requestFocus();
                serverIpField.selectAll();
            }
        }
        else if(event.target==serverIpField){
            if(shift){
                nameField.requestFocus();
                nameField.selectAll();
            }
            else{
                serverPortField.requestFocus();
                serverPortField.selectAll();
            }
        }
        else if(event.target==serverPortField){
            if(shift){
                serverIpField.requestFocus();
                serverIpField.selectAll();
            }
            else{
                conferenceNameField.requestFocus();
                conferenceNameField.selectAll();
            }
        }
        else if(event.target==conferenceNameField){
            if(shift){
                serverPortField.requestFocus();
                serverPortField.selectAll();
            }
            else connectButton.requestFocus();
        }
        else if(event.target==connectButton){
            if(shift) conferenceNameField.requestFocus();
            else cancelButton.requestFocus();
        }
        else if(event.target==cancelButton){
            if(shift) connectButton.requestFocus();
            else{
                nameField.requestFocus();
                nameField.selectAll();
            }
        }

    }

    public void clickedConnectButton() {
        dispose();
        ((ResultProcessor)getParent()).processResult(this,new ConnectInfo(nameField.getText(),serverIpField.getText(),
            serverPortField.getText(),conferenceNameField.getText()));
    }
    public void clickedCancelButton() {
        dispose();
    }


}// End of ConnectDialog2 class


