//CurrentColors.java
import java.awt.*;
import java.lang.*;

class CurrentColors extends Canvas{

  private int defaultColorBoxSize=30;
  private int currentColorBoxSize=defaultColorBoxSize;
  private int defaultFrameWidth=5;
  private int currentFrameWidth=defaultFrameWidth;

  private Color Background=Color.lightGray;
  private Color defaultForegroundColor=Color.black;
  private Color defaultBackgroundColor=Color.white;
  private Color ForegroundColor=defaultForegroundColor;
  private Color BackgroundColor=defaultBackgroundColor;

  public CurrentColors(){
    super();
    int width=(int)Math.ceil(((double)currentColorBoxSize)*3/2)+currentFrameWidth*2;
    int height=width;
    resize(width,height);
    setBackground(Background);
    show();
  }

  public CurrentColors(Color fground,Color bground){
    super();
    int width=(int)Math.ceil(((double)currentColorBoxSize)*3/2)+currentFrameWidth*2;
    int height=width;
    ForegroundColor=fground;
    BackgroundColor=bground;
    resize(width,height);
    setBackground(Background);
    show();
  }
  public void paint(Graphics g){
    g.setColor(BackgroundColor);
    g.fillRect(currentFrameWidth+defaultColorBoxSize/2,currentFrameWidth+defaultColorBoxSize/2,defaultColorBoxSize,defaultColorBoxSize);
    g.setColor(Color.black);
    g.drawRect(currentFrameWidth+defaultColorBoxSize/2,currentFrameWidth+defaultColorBoxSize/2,defaultColorBoxSize,defaultColorBoxSize);
    g.setColor(ForegroundColor);
    g.fillRect(currentFrameWidth,currentFrameWidth,defaultColorBoxSize,defaultColorBoxSize);
    g.setColor(Color.black);
    g.drawRect(currentFrameWidth,currentFrameWidth,defaultColorBoxSize,defaultColorBoxSize);
  }


  public void setForegroundColor(Color color){
    ForegroundColor=color;
    repaint(currentFrameWidth,currentFrameWidth,defaultColorBoxSize,defaultColorBoxSize);
  }

  public void setBackgroundColor(Color color){
    BackgroundColor=color;
    repaint();
  }

}

