// FontHelper.java

import java.awt.*;
import java.util.*;

public class FontHelper{

  Toolkit toolkit;
  private String fontNames[];
  private String fontStyles[]={"Plain","Bold","Italic"};
  private int intFontSizes[]={10,12,14,18,24,36,72,86};// add for more sizes
  private String fontSizes[];
  private String fontMenuItems[];
  private String sizeMenuItems[];
  private String styleMenuItems[];
  private String temp=null;

  private Font defaultFont;
  private String defaultFontName;
  private int defaultFontSize;
  private int defaultFontStyle;

  private String newFontName;
  private int newFontSize;
  private int newFontStyle;


  public FontHelper(Toolkit toolkit){

    // create a list of fontnames using
    // available fonts from parent frame
    //toolkit=owner.getToolkit();
    fontNames=toolkit.getFontList();

    // creating default font of:
    // 1st font in fontNames
    // static Font.PLAIN
    // 1st Size in intFontSizes
    defaultFontName=fontNames[2].toString();
    defaultFontStyle=Font.PLAIN;// do not change this line !
    defaultFontSize=intFontSizes[4];
    defaultFont=new Font(defaultFontName,defaultFontStyle=Font.PLAIN,defaultFontSize);


    // copy defaultFontStyle to newFontStyle
    newFontName=defaultFontName;
    // copy defaultFontStyle to newFontStyle
    newFontStyle=defaultFontStyle;
    // copy defaultFontSize to newFontSize
    newFontSize=defaultFontSize;



    // create a list of fonts
    // where 1st item is "Font" and
    // the default font name hasis preceded by a '+' and
    // the other names are preceded by a '-'
    fontMenuItems=new String[fontNames.length+1];
    fontMenuItems[0]="Font".toString();
    for(int i=0;i<fontNames.length;i++){
      if(fontNames[i].toString()==defaultFont.getName())
        fontMenuItems[i+1]=("+"+(fontNames[i].toString()));
      else
        fontMenuItems[i+1]=("-"+(fontNames[i].toString()));
    }

    // create a String list of sizes
    fontSizes=new String[intFontSizes.length];
    for(int i=0;i<intFontSizes.length;i++)
      fontSizes[i]=(temp.valueOf(intFontSizes[i]));

    // create a  String list of sizes
    // where 1st item is "Size" and
    // the default font size is preceded by a '+' and
    // the other sizes are preceded by a '-'
    sizeMenuItems=new String[intFontSizes.length+1];
    sizeMenuItems[0]="Size".toString();
    for(int i=0;i<intFontSizes.length;i++){
      if(defaultFont.getSize()==intFontSizes[i])
        sizeMenuItems[i+1]=("+"+temp.valueOf(intFontSizes[i]));
      else
        sizeMenuItems[i+1]=("-"+temp.valueOf(intFontSizes[i]));
    }
    // create a  String list of styles
    // where 1st item is "Style" and
    // the default style size is preceded by a '+' and
    // the other styles are preceded by a '-'
    styleMenuItems=new String[fontStyles.length+1];
    styleMenuItems[0]="Style".toString();
    for(int i=0;i<fontStyles.length;i++){
      if(i==0)
        styleMenuItems[i+1]=("+"+fontStyles[i].toString());
      else
        styleMenuItems[i+1]=("-"+fontStyles[i].toString());
    }
  }


  Font newFont(){
    Font temp=new Font(newFontName,newFontStyle,newFontSize);
    return temp;
  }

  public Font getDefaultFont(){
    return defaultFont;
  }

  public Font changeName(String name){
    newFontName=name;
    return newFont();
  }

  public Font changeSize(int index){
    newFontSize=intFontSizes[index];
    return newFont();
  }

  public Font changeStyle(int style){
    newFontStyle+=style;
    return newFont();
  }

  public String[] getFontMenuItems(){
    return fontMenuItems;
  }

  public String[] getSizeMenuItems(){
    return sizeMenuItems;
  }

  public String[] getStyleMenuItems(){
    return styleMenuItems;
  }


  public String[] getFontNames(){
    return fontNames;
  }

  public String[] getFontSizes(){
    return fontSizes;
  }

  public String[] getFontStyles(){
    return fontStyles;
  }

}


