

// TwoPointObject.java

import java.awt.*;
import java.lang.Math;
//import java.util.Vector;

class TwoPointObject{
  // Variable Declarations
  public static int LINE=0;
  public static int OVAL=1;
  public static int FILLED_OVAL=2;
  public static int RECTANGLE=3;
  public static int FILLED_RECTANGLE=4;
  public static int FREEHAND=5;
  public static int TEXT=6;
  public int type, startX, startY, endX, endY, objectId=0, fill=0, objectLineWidth=1;
  Color objectColor=Color.black;
  boolean debug=false;

  // Method Declarations

  // Constructor TwoPointObject()
  public TwoPointObject(int objectType,int i,int x1,int y1,int x2,int y2,int f){
    type =objectType;
    //objectId=id;
    startX=x1;
    startY=y1;
    endX=x2;
    endY=y2;
    fill=f;

  }

  // Constructor TwoPointObject()
  public TwoPointObject(int objectType,int x1,int y1,int x2,int y2){
    type =objectType;
    //objectId=id;
    startX=x1;
    startY=y1;
    endX=x2;
    endY=y2;

  }

  // Constructor TwoPointObject()
  public TwoPointObject(int objectType,int x, int y){
    this(objectType,x,y,x,y);
    //objectId=id;

  }

  // Constructor TwoPointObject()
  public TwoPointObject(){
    this(LINE,0,0,0,0);
    //objectId=id;

  }

  // Method setColor()
  public void setColor(Color color){
    objectColor=color;
  }


  // Method getColor()
  public Color getColor(){
    return objectColor;
  }

  // Method setId()
  public void setId(int id ){
    objectId=id;
  }

  // Method getId()
  public int getId(){
    return objectId;
  }

  // Method setLineWidth()
  public void setLineWidth(int width){
    objectLineWidth=width;
  }

  // Method getLineWidth
  public int getLineWidth(){
    return objectLineWidth;
  }

  // Method delete()
  public boolean delete(int id){
    return true;
    }





  // Method draw()
  public void draw(Graphics g){
    g.setColor(objectColor);
    if(type==LINE){
      if(objectLineWidth==1)
        g.drawLine(startX,startY,endX,endY);
      else{
        float t=0,x=0,y=0,x1,x2,y1,y2,increment,lineLength;
        x1=(float)startX;
        x2=(float)endX;
        y1=(float)startY;
        y2=(float)endY;
        lineLength=(float)Math.sqrt((double)((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)));
        increment=objectLineWidth/(lineLength*2);
        for(t=0;t<=1;t+=increment){
          x=Math.round(x1+(x2-x1)*t);
          y=Math.round(y1+(y2-y1)*t);
          g.fillRect((int)x,(int)y,objectLineWidth,objectLineWidth);
        }
      }
    }
    else{
      int w=Math.abs(endX-startX);
      int l=Math.abs(endY-startY);
      if(type==OVAL){
        for(int i=0;i<objectLineWidth;++i) g.drawOval(startX+i,startY+i,w-i*2,l-i*2);
      }
      else if(type==FILLED_OVAL) g.fillOval(startX,startY,w,l);
      else if(type==FILLED_RECTANGLE) g.fillRect(startX,startY,w,l);

      else if(type==RECTANGLE){
        for(int i=0;i<objectLineWidth;++i) g.drawRect(startX+i,startY+i,w-i*2,l-i*2);
      }
      // rewrite this if statement
      else if(type==FREEHAND)
        if(objectLineWidth==1) g.drawLine(startX,startY,startX,startY);
        else g.fillRect(startX,startY,objectLineWidth,objectLineWidth);
    }
  }
}// End of TwoPointObject class
